; $Id: fisv.pro,v 1.60 2007/07/05 10:40:04 makiuti Exp $
;
; FIS Data Visualizer (FISv) Procedures
;
; Copyright (c) 2003-2007, AKARI(ASTRO-F) Data Reduction Team.  All rights reserved.
;
;+
; NAME:
;       FISV
;
; PURPOSE:
;       The purpose of this program is to display a time series data (TSD)
;       of the ASTRO-F/FIS survey data. "fisv.pro" calls "fisv_eventcb.pro".
;       ### See also the header of fisv_eventcb.pro. ###
;
; AUTHOR:
;       ASTRO-F Data Reduction team
;       Web Page: http://www.ir.isas.jaxa.jp/AKARI/iris_data/
;
; CATEGORY:
;       FIS Data Visualizer
;       Widgets program
;
; CALLING SEQUENCE:
;       fisv
;-
;
pro FISV_BASE_0_event, Event

On_Error, 2

  wTarget = (widget_info(Event.id,/NAME) eq 'TREE' ?  $
      widget_info(Event.id, /tree_root) : event.id)

  wWidget =  Event.top

  case wTarget of

    ;## Menu 1 (Files) ##
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Open'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        FileOpen, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_LDS'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        FileOpenLDS, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Save'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        FileSave, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Exit'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        OnExit, Event
    end

    ;## Menu 2 (Main functions) ##
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Plot'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        PlotBtn, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Table'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        TableBtn, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Print'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        PrintBtn, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_PS'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        PSBtn, Event
    end

    ;## Menu 3 (Tools) ##
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_HeadView'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        HeaderView, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_DetImage'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        DetImage, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_AfTime2Date'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        CnvAfTime2Date, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_SvVdet'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        SaveVdet, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_MkSubTSD'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        Mk_SubTSD, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_ShVlist'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        ListVdetSig, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_PSVlist'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        PSListVdetSig, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_FFT'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        FFT_DATA, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_EDIT'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        TSD_EDIT, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_ClearFlag'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        Clear_Flag, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_MaskPlot'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        MaskPlot, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_SetBad'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        SetBad, Event
    end

    ;## Menu 4 (GB pipeline)##
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_GBbatch'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_batch_proc, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_FlgB'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_FlagBD, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_CnvV'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_Conv2Volt, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_RAnm'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_FlagRAnm, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_RCcr'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_RCcrr, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Diff'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_Diff, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Peri'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_Peri, Event
    end
;    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Sglc'): begin
;      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
;        GB_SetGS, Event
;    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_MTGL'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_MTGL, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_GPGL'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_GPGL, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_MCLT'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_MCLT, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_MDKT'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_MDKT, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_DKSb'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_DKSb, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_ResC'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_ResC, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_FlxC'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_FluxC, Event
    end

    ;## Menu 5 (Help)##
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_Help'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        OnLineHelp, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_EEnv'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        EditEnvFile, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='W_MENU_About'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        ShowAbout, Event
    end

    ;## Main Button events ##
    Widget_Info(wWidget, FIND_BY_UNAME='Open_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        FileOpen, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='LDS_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        FileOpenLDS, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Save_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        FileSave, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Exit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        OnExit, Event
    end

    Widget_Info(wWidget, FIND_BY_UNAME='WID_TREE_0'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TREE_SEL' )then $
        XDataSelected, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_TREE_1'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TREE_SEL' )then $
        YDataSelected, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_0'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        PlotBtn, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_4'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        TableBtn, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_1'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        PrintBtn, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_2'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        PSBtn, Event
    end

    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_HeadView'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        HeaderView, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_VdetList'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        ListVdetSig, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_DetImage'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        DetImage, Event
    end
;    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_SvVdet'): begin
;      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
;        SaveVdet, Event
;    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_MaskPlot'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        MaskPlot, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_TSDEdit'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        TSD_EDIT, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_gbBatch'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_batch_proc, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_gbFlgBad'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_FlagBD, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_gbCnvV'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_Conv2Volt, Event
    end
;    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_gbRampCorr'): begin
;      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
;        GB_RCcrr, Event
;    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_gbDiff'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        GB_Diff, Event
    end

    else:
  endcase

end

pro FISV_BASE_0, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Resolve_Routine, 'fisv_eventcb',/COMPILE_FULL_FILE  ; Load event callback routines

  ; Read a FISv Environment Setup file
  Set_Env_FISv

  ; for IDL VM (but GB doesn't work on VM yet at 2006/09/01)
  ;fisdr

  ;;;;
  FISV_BASE_0 = Widget_Base( GROUP_LEADER=wGroup, UNAME='FISV_BASE_0'  $
      ,XOFFSET=80 ,YOFFSET=100 ,TITLE='FISv - FIS Data Visualizer' ,COLUMN=1  $
      ,MBAR=FISV_BASE_0_MBAR)

  ;============
  ;  Menu
  ;============
  ; Menu Bar 1
  W_MENU_1 = Widget_Button(FISV_BASE_0_MBAR, UNAME='W_MENU_1' ,/MENU  $
      ,VALUE='File')

  W_MENU_Open = Widget_Button(W_MENU_1, UNAME='W_MENU_Open' ,VALUE='Open...')
  W_MENU_LDS = Widget_Button(W_MENU_1, UNAME='W_MENU_LDS' ,VALUE='Open from LDS...')
  W_MENU_Save = Widget_Button(W_MENU_1, UNAME='W_MENU_Save' ,VALUE='Save as...')
  W_MENU_Exit = Widget_Button(W_MENU_1, UNAME='W_MENU_Exit' ,/SEPARATOR  $
      ,VALUE='Exit')

  ; Menu Bar 2
  W_MENU_2 = Widget_Button(FISV_BASE_0_MBAR, UNAME='W_MENU_2' ,/MENU  $
      ,VALUE='Main')

  W_MENU_Plot = Widget_Button(W_MENU_2, UNAME='W_MENU_Plot' ,SENSITIVE=0  $
      ,VALUE='Plot selected data')
  W_MENU_Table = Widget_Button(W_MENU_2, UNAME='W_MENU_Table' ,SENSITIVE=0  $
      ,VALUE='Display Table of selected data')
  W_MENU_Print = Widget_Button(W_MENU_2, UNAME='W_MENU_Print' ,SENSITIVE=0  $
      ,VALUE='Print out Plot...')
  W_MENU_PS = Widget_Button(W_MENU_2, UNAME='W_MENU_PS' ,SENSITIVE=0  $
      ,VALUE='Make PS file of Plot...')

  ; Menu Bar 3
  W_MENU_3 = Widget_Button(FISV_BASE_0_MBAR, UNAME='W_MENU_3' ,/MENU  $
      ,VALUE='Tools')

  W_MENU_MaskPlot = Widget_Button(W_MENU_3, UNAME='W_MENU_MaskPlot' ,SENSITIVE=0  $
      ,VALUE='Masked Plot of DET and FLUX')
  W_MENU_SetBad = Widget_Button(W_MENU_3, UNAME='W_MENU_SetBad' ,SENSITIVE=0  $
      ,VALUE='BAD Flag Setting Tool')
  W_MENU_EDIT = Widget_Button(W_MENU_3, UNAME='W_MENU_EDIT' ,SENSITIVE=0  $
      ,VALUE='TSD Editor')
  W_MENU_FFT = Widget_Button(W_MENU_3, UNAME='W_MENU_FFT' ,SENSITIVE=0  $
      ,VALUE='FFT...')

  W_MENU_DetImage = Widget_Button(W_MENU_3, UNAME='W_MENU_DetImage' ,SENSITIVE=0  $
      ,/SEPARATOR ,VALUE='Image View of Detector Array Signal')
  W_MENU_ShVlist = Widget_Button(W_MENU_3, UNAME='W_MENU_ShVlist' ,SENSITIVE=0  $
      ,VALUE='Plot All pixels of DET or FLUX')
  W_MENU_PSVlist = Widget_Button(W_MENU_3, UNAME='W_MENU_PSVlist' ,SENSITIVE=0  $
      ,VALUE='Make PS of All pixels plot of DET or FLUX...')

  W_MENU_SvVdet = Widget_Button(W_MENU_3, UNAME='W_MENU_SvVdet' ,SENSITIVE=0  $
      ,/SEPARATOR ,VALUE='Save detector values as Text file...')

  W_MENU_MkSubTSD = Widget_Button(W_MENU_3, UNAME='W_MENU_MkSubTSD' ,SENSITIVE=0  $
      ,/SEPARATOR ,VALUE='Make Subset from the current TSD...')
  W_MENU_HeadView = Widget_Button(W_MENU_3, UNAME='W_MENU_HeadView' ,SENSITIVE=0  $
      ,VALUE='FITS Header Viewer for TSD')
  W_MENU_AfTime2Date = Widget_Button(W_MENU_3, UNAME='W_MENU_AfTime2Date' ,SENSITIVE=0  $
      ,VALUE='AFTime to Date Conversion tool')
  W_MENU_ClearFlag = Widget_Button(W_MENU_3, UNAME='W_MENU_ClearFlag' ,SENSITIVE=0  $
      ,VALUE='Clear All Flags and Qualities...')

  ; Menu Bar 4
  W_MENU_4 = Widget_Button(FISV_BASE_0_MBAR, UNAME='W_MENU_4' ,/MENU  $
      ,VALUE='Pipeline')

  W_MENU_GBbatch = Widget_Button(W_MENU_4, UNAME='W_MENU_GBbatch' ,SENSITIVE=0  $
      ,VALUE='GB Batch Processing...')

  W_MENU_FlgB = Widget_Button(W_MENU_4, UNAME='W_MENU_FlgB' ,SENSITIVE=0  $
      ,VALUE='GB_Flag_Bad_Data',/SEPARATOR)
  W_MENU_RAnm = Widget_Button(W_MENU_4, UNAME='W_MENU_RAnm' ,SENSITIVE=0  $
      ,VALUE='GB_Set_Flag_Rstanom')
  W_MENU_CnvV = Widget_Button(W_MENU_4, UNAME='W_MENU_CnvV' ,SENSITIVE=0  $
      ,VALUE='GB_Conv_to_Volt')
  W_MENU_CnvV = Widget_Button(W_MENU_4, UNAME='W_MENU_RCcr' ,SENSITIVE=0  $
      ,VALUE='GB_Ramp_Curve_Corr...')
  W_MENU_Diff = Widget_Button(W_MENU_4, UNAME='W_MENU_Diff' ,SENSITIVE=0  $
      ,VALUE='GB_Differentiation')
  W_MENU_Peri = Widget_Button(W_MENU_4, UNAME='W_MENU_Peri' ,SENSITIVE=0  $
      ,VALUE='GB_Periodic_Noise')
;  W_MENU_Diff = Widget_Button(W_MENU_4, UNAME='W_MENU_Sglc' ,SENSITIVE=0  $
;      ,VALUE='GB_Set_Glitch_Status')
  W_MENU_MTGL = Widget_Button(W_MENU_4, UNAME='W_MENU_MTGL' ,SENSITIVE=0  $
      ,VALUE='GB_Set_Glitch_Status_MMT')
  W_MENU_GPGL = Widget_Button(W_MENU_4, UNAME='W_MENU_GPGL' ,SENSITIVE=0  $
      ,VALUE='GB_Set_Glitch_Status_GP')
  W_MENU_MCLT = Widget_Button(W_MENU_4, UNAME='W_MENU_MCLT' ,SENSITIVE=0  $
      ,VALUE='GB_Make_DC_Cal_Lamp_Table...')
  W_MENU_MDKT = Widget_Button(W_MENU_4, UNAME='W_MENU_MDKT' ,SENSITIVE=0  $
      ,VALUE='GB_Make_Dark_Table...')
  W_MENU_DKSb = Widget_Button(W_MENU_4, UNAME='W_MENU_DKSb' ,SENSITIVE=0  $
      ,VALUE='GB_Dark_Subtraction')
  W_MENU_ResC = Widget_Button(W_MENU_4, UNAME='W_MENU_ResC' ,SENSITIVE=0  $
      ,VALUE='GB_DC_Responsivity_Corr')
  W_MENU_FlxC = Widget_Button(W_MENU_4, UNAME='W_MENU_FlxC' ,SENSITIVE=0  $
      ,VALUE='GB_Flux_Calib')

  ; Menu Bar 5
  W_MENU_5 = Widget_Button(FISV_BASE_0_MBAR, UNAME='W_MENU_5' ,/MENU  $
      ,VALUE='Help')

  W_MENU_Help = Widget_Button(W_MENU_5, UNAME='W_MENU_Help' $
      ,VALUE='Online Help...')
  W_MENU_EEnv = Widget_Button(W_MENU_5, UNAME='W_MENU_EEnv' $
      ,VALUE='Edit FISv environment file...')
  W_MENU_About = Widget_Button(W_MENU_5, UNAME='W_MENU_About' $
      ,VALUE='About...')

  ;============
  ; Fundamental Base
  ;============
  WID_BASE_1 = Widget_Base(FISV_BASE_0, UNAME='WID_BASE_1' ,/COLUMN)

  ;============
  ;  Tool bar
  ;============
  IconBase=Widget_Base(WID_BASE_1, row=1)
  Open_Button=widget_button(iconbase, value='open_fisv.bmp', /bitmap, UNAME='Open_BUTTON' $
      , TOOLTIP='Open TSD file')
  LDS_Button=widget_button(iconbase, value='lds_fisv.bmp', /bitmap, UNAME='LDS_BUTTON' $
      , TOOLTIP='Open TSD file from LDS')
  Save_Button=widget_button(iconbase, value='save.bmp', /bitmap, UNAME='Save_BUTTON' $
      , TOOLTIP='Save TSD file')
  Exit_Button=widget_button(iconbase, value='exit_fisv.bmp', /bitmap, UNAME='Exit_BUTTON')
      ;, TOOLTIP='Exit') ; <- to avoid crash on unix machines

  ;============
  ; Filename box
  ;============
  WID_BASE_2 = Widget_Base(WID_BASE_1, UNAME='WID_BASE_2' ,FRAME=1  $
      , SCR_XSIZE=640, SCR_YSIZE=20, /COLUMN, SENSITIVE=0)

  WID_LABEL_0 = Widget_Label(WID_BASE_2, UNAME='WID_LABEL_0'  $
      , XSIZE=635, /ALIGN_CENTER , VALUE='File Not Opened')

  ;============
  WID_BASE_3 = Widget_Base(WID_BASE_1, UNAME='WID_BASE_3' ,YOFFSET=20  $
      ,ROW=1, SENSITIVE=0)


  WID_BASE_4 = Widget_Base(WID_BASE_3, UNAME='WID_BASE_4' ,FRAME=1  $
      ,COLUMN=1)


  WID_BASE_5 = Widget_Base(WID_BASE_4, UNAME='WID_BASE_5'  $
      ,ROW=1)

  ;============
  ; X & Y Data Selector Trees
  ;============
  WID_BASE_8 = Widget_Base(WID_BASE_5, UNAME='WID_BASE_8'  $
      ,COLUMN=1)

  WID_LABEL_1 = Widget_Label(WID_BASE_8, UNAME='WID_LABEL_1'  $
      ,/ALIGN_LEFT ,VALUE='X axis')

  WID_TREE_0 = Widget_Tree(WID_BASE_8, UNAME='WID_TREE_0' ,YOFFSET=14  $
      ,SCR_XSIZE=200 ,SCR_YSIZE=Float(GetEnv('TREE_Y_SIZE')) )

  WID_BASE_9 = Widget_Base(WID_BASE_5, UNAME='WID_BASE_9'  $
      ,COLUMN=1)

  WID_LABEL_2 = Widget_Label(WID_BASE_9, UNAME='WID_LABEL_2'  $
      ,/ALIGN_LEFT ,VALUE='Y axis')

  WID_TREE_1 = Widget_Tree(WID_BASE_9, UNAME='WID_TREE_1' ,YOFFSET=14  $
      ,SCR_XSIZE=200 ,SCR_YSIZE=Float(GetEnv('TREE_Y_SIZE')) ,/MULTIPLE)

  make_initial_tree, WID_BASE_8 ; can replace WID_BASE_8 with any widgets

  ;============
  ; Make main function buttons
  ;============
  WID_BASE_6 = Widget_Base(WID_BASE_4, UNAME='WID_BASE_6' ,XOFFSET=20  $
      ,YOFFSET=214,/ALIGN_CENTER ,ROW=1)


  WID_BUTTON_0 = Widget_Button(WID_BASE_6, UNAME='WID_BUTTON_0'  $
      ,SCR_XSIZE=75 ,SCR_YSIZE=25 ,/ALIGN_CENTER ,VALUE='Plot' $
      ,TOOLTIP='Plot selected data')

  WID_BUTTON_4 = Widget_Button(WID_BASE_6, UNAME='WID_BUTTON_4'  $
      ,SCR_XSIZE=75 ,SCR_YSIZE=25 ,/ALIGN_CENTER  $
      ,VALUE='Table', TOOLTIP='Show data table')

  WID_BUTTON_1 = Widget_Button(WID_BASE_6, UNAME='WID_BUTTON_1'  $
      ,SCR_XSIZE=75 ,SCR_YSIZE=25 ,/ALIGN_CENTER  $
      ,VALUE='Print', TOOLTIP='Print out')

  WID_BUTTON_2 = Widget_Button(WID_BASE_6, UNAME='WID_BUTTON_2'  $
      ,SCR_XSIZE=75 ,SCR_YSIZE=25 ,/ALIGN_CENTER  $
      ,VALUE='PS', TOOLTIP='Save as a PostScript file')

  ;============
  ; Preview window
  ;============
  WID_BASE_7 = Widget_Base(WID_BASE_3, UNAME='WID_BASE_7'  $
      ,XOFFSET=280 ,SPACE=10 ,COLUMN=1)


  WID_DRAW_0 = Widget_Draw(WID_BASE_7, UNAME='WID_DRAW_0'  $
      ,SCR_XSIZE=200 ,SCR_YSIZE=150)

  ;============
  ; Tools
  ;============
  WID_BASE_11 = Widget_Base(WID_BASE_7, UNAME='WID_BASE_11' ,FRAME=1  $
      , SCR_YSIZE=175, /Column)

  ; Base for Functions
  WID_BASE_FncBtnBase = Widget_Base(WID_BASE_11, UNAME='WID_BASE_FncBtnBase' $
      ,/Column)

  ; base1
  WID_BASE_BtnBase1 = Widget_Base(WID_BASE_FncBtnBase, UNAME='WID_BASE_BtnBase1' $
      , /Row)

  WID_BUTTON_HeadView = Widget_Button(WID_BASE_BtnBase1, UNAME='WID_BUTTON_HeadView'  $
      ,/ALIGN_CENTER, XSIZE=85, VALUE='Header View', TOOLTIP='FITS Header Viewer for TSD')
  WID_BUTTON_VdetList = Widget_Button(WID_BASE_BtnBase1, UNAME='WID_BUTTON_VdetList'  $
      ,/ALIGN_CENTER, XSIZE=85, VALUE='Plot All', TOOLTIP='Plot All pixels of DET or FLUX')

  ; base2
  WID_BASE_BtnBase2 = Widget_Base(WID_BASE_FncBtnBase, UNAME='WID_BASE_BtnBase2' $
      , /Row)

  WID_BUTTON_DetImage = Widget_Button(WID_BASE_BtnBase2, UNAME='WID_BUTTON_DetImage'  $
      ,/ALIGN_CENTER, XSIZE=85, VALUE='Image of det', TOOLTIP='Image View of Detector Array Signal')
  WID_BUTTON_MaskPlot = Widget_Button(WID_BASE_BtnBase2, UNAME='WID_BUTTON_MaskPlot'  $
      ,/ALIGN_CENTER ,XSIZE=85, VALUE='Masked Plot', TOOLTIP='Make Plot masked by Flags (for DET and FLUX)')

  ; base3
  WID_BASE_BtnBase3 = Widget_Base(WID_BASE_FncBtnBase, UNAME='WID_BASE_BtnBase3' $
      , /Row)

  WID_BUTTON_TSDEdit = Widget_Button(WID_BASE_BtnBase3, UNAME='WID_BUTTON_TSDEdit'  $
      ,/ALIGN_CENTER ,XSIZE=80, VALUE='TSD Editor', TOOLTIP='Edit Values in TSD')


  ; Base for GB modules
  WID_BASE_BtnBase4 = Widget_Base(WID_BASE_11, UNAME='WID_BASE_BtnBase4' $
      ,/Column)

  ; GB base 1
  WID_BASE_GBBase1 = Widget_Base(WID_BASE_BtnBase4, UNAME='WID_BASE_GBBase1' $
      , /Row)

  WID_BUTTON_gbBatch = Widget_Button(WID_BASE_GBBase1, UNAME='WID_BUTTON_gbBatch'  $
      ,/ALIGN_CENTER ,XSIZE=85, VALUE='GB Batch', TOOLTIP='GB Batch Processing')
  WID_BUTTON_gbFlgBad = Widget_Button(WID_BASE_GBBase1, UNAME='WID_BUTTON_gbFlgBad'  $
      ,/ALIGN_CENTER ,XSIZE=85, VALUE='GB FlagBad', TOOLTIP='Call GB_Flag_Bad_Data')


  ; GB base 2
  WID_BASE_GBBase2 = Widget_Base(WID_BASE_BtnBase4, UNAME='WID_BASE_GBBase2' $
      , /Row)

  WID_BUTTON_gbCnvV = Widget_Button(WID_BASE_GBBase2, UNAME='WID_BUTTON_gbCnvV'  $
      ,/ALIGN_CENTER ,XSIZE=85, VALUE='GB Cnv2V', TOOLTIP='Call GB_Conv_to_Volt')
;  WID_BUTTON_gbRampCorr = Widget_Button(WID_BASE_GBBase2, UNAME='WID_BUTTON_gbRampCorr'  $
;      ,/ALIGN_CENTER ,XSIZE=85, VALUE='GB RampCorr', TOOLTIP='Call GB_Ramp_Curve_Corr')
  WID_BUTTON_gbDiff = Widget_Button(WID_BASE_GBBase2, UNAME='WID_BUTTON_gbDiff'  $
      ,/ALIGN_CENTER ,XSIZE=85, VALUE='GB Diff', TOOLTIP='Call GB_Differentiation')

  ;============
  ; Message Box
  ;============
  WID_BASE_10 = Widget_Base(FISV_BASE_0, UNAME='WID_BASE_10'  $
      ,XOFFSET=5 ,YOFFSET=260 ,SENSITIVE=0 ,/ALIGN_CENTER)

  WID_TEXT_0 = Widget_Text(WID_BASE_10, UNAME='WID_TEXT_0' ,/SCROLL $
      ,/WRAP ,VALUE=[ 'Minasan, Gokigenyou!', 'Good day, everybody!' $
      , '(c)ISAS/JAXA  "AKARI/FIS Data (TSD) Visualizer" Ver. 3.16 for TSD4' ] $
      ,XSIZE=101 ,YSIZE=5)

  ;============
  Widget_Control, /REALIZE, FISV_BASE_0

  XManager, 'FISV_BASE_0', FISV_BASE_0, /NO_BLOCK

end
;
; Empty stub procedure used for autoloading.
;
pro fisv, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  FISV_BASE_0, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
