; $Id: gb_batch.pro,v 1.3 2007/07/05 10:40:04 makiuti Exp $
;+
; NAME:
;       GB_BATCH
;
; PURPOSE:
;       The purpose of this procedure is to run continuously
;        GB pipelins which have been selected with GUI dialogue.
;
; AUTHOR:
;       ASTRO-F Data Reduction team
;       Web Page: http://www.ir.isas.jaxa.jp/AKARI/iris_data/
;
; CATEGORY:
;       FIS Data Visualizer
;
; CALLING SEQUENCE:
;       gb_batch, GROUP_LEADER=wGroup
;         wGroup is top level ID of the FISv
;
; MODIFICATION HISTORY:
;        07/01/05 Written by: Makiuti,S.
;        07/01/09 Last modified
;-
;
;-----------------------------------------------------------------
; OK Button, run GB pipelines
;-----------------------------------------------------------------
pro gb_batch_run, Event
COMMON GBB_Share, fisv_top_id, gb_batch_info
COMMON ShareFISv

CF = widget_info(Event.top, find_by_uname='CF')
flag_cf  = Widget_info(CF, /Button_Set)
GB1 = widget_info(Event.top, find_by_uname='GB1')
flag_gb1 = Widget_info(GB1, /Button_Set)
GB2 = widget_info(Event.top, find_by_uname='GB2')
flag_gb2 = Widget_info(GB2, /Button_Set)
GB3 = widget_info(Event.top, find_by_uname='GB3')
flag_gb3 = Widget_info(GB3, /Button_Set)
GB4 = widget_info(Event.top, find_by_uname='GB4')
flag_gb4 = Widget_info(GB4, /Button_Set)
GB5 = widget_info(Event.top, find_by_uname='GB5')
flag_gb5 = Widget_info(GB5, /Button_Set)
GB6 = widget_info(Event.top, find_by_uname='GB6')
flag_gb6 = Widget_info(GB6, /Button_Set)
GB7 = widget_info(Event.top, find_by_uname='GB7')
flag_gb7 = Widget_info(GB7, /Button_Set)
GB8 = widget_info(Event.top, find_by_uname='GB8')
flag_gb8 = Widget_info(GB8, /Button_Set)
GB9 = widget_info(Event.top, find_by_uname='GB9')
flag_gb9 = Widget_info(GB9, /Button_Set)
GB10 = widget_info(Event.top, find_by_uname='GB10')
flag_gb10 = Widget_info(GB10, /Button_Set)
GB11 = widget_info(Event.top, find_by_uname='GB11')
flag_gb11 = Widget_info(GB11, /Button_Set)
GB12 = widget_info(Event.top, find_by_uname='GB12')
flag_gb12 = Widget_info(GB12, /Button_Set)
GB13 = widget_info(Event.top, find_by_uname='GB13')
flag_gb13 = Widget_info(GB13, /Button_Set)

; Information structure to keep the last parameters.
  gb_batch_info = { $
    flag_cf :flag_cf , $
    flag_gb1:flag_gb1, $
    flag_gb2:flag_gb2, $
    flag_gb3:flag_gb3, $
    flag_gb4:flag_gb4, $
    flag_gb5:flag_gb5, $
    flag_gb6:flag_gb6, $
    flag_gb7:flag_gb7, $
    flag_gb8:flag_gb8, $
    flag_gb9:flag_gb9, $
    flag_gb10:flag_gb10, $
    flag_gb11:flag_gb11, $
    flag_gb12:flag_gb12, $
    flag_gb13:flag_gb13 $
    }

; If any GBs are checked
IF (flag_cf OR flag_gb1 OR flag_gb2 OR flag_gb3 OR flag_gb4 OR flag_gb5 OR flag_gb6 OR flag_gb7 $
    OR flag_gb8 OR flag_gb9 OR flag_gb10 OR flag_gb11 OR flag_gb12 OR flag_gb13) THEN BEGIN

  WIDGET_CONTROL, /HOURGLASS

  gb_arr = [flag_gb1, flag_gb2, flag_gb3, flag_gb4, flag_gb5, flag_gb6, flag_gb7, $
            flag_gb8, flag_gb9, flag_gb10, flag_gb11, flag_gb12, flag_gb13]
  gb_idx = where(gb_arr NE 0)+1

  IF (flag_cf EQ 1) THEN BEGIN
    clear_all_flag, tsd
    print, 'Clear Flag in FIS_OBS'
  ENDIF

  IF (gb_idx[0] GT 0) THEN BEGIN
    r = gb_run_gb(tsd, OUTFILE=-1, Enable_GB=gb_idx, FERR=0)
  ENDIF

ENDIF ELSE BEGIN
    result = DIALOG_MESSAGE(['No module was selected.'], DIALOG_PARENT=fisv_top_id, /ERROR)
    print, 'No module was selected.'
ENDELSE

  WIDGET_CONTROL, Event.top, /DESTROY
  return

end
;-----------------------------------------------------------------
; Cancel Button
;-----------------------------------------------------------------
pro gb_batch_cancel, Event

  WIDGET_CONTROL, Event.top, /DESTROY
  return

end
;-----------------------------------------------------------------
; Event check
;-----------------------------------------------------------------
pro gb_batch_Box_event, Event

  wTarget = (widget_info(Event.id,/NAME) eq 'TREE' ?  $
      widget_info(Event.id, /tree_root) : event.id)


  wWidget =  Event.top

  case wTarget of

    Widget_Info(wWidget, FIND_BY_UNAME='RUN_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        gb_batch_run, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        gb_batch_cancel, Event
    end
    else:
  endcase

end

pro gb_batch_Box, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
COMMON GBB_Share, fisv_top_id, gb_batch_info

  ; Get geometry information of the FISv toplevel window
  fisv_top_geom = Widget_info(fisv_top_id, /GEOMETRY)

  gb_batch_Box = Widget_Base( GROUP_LEADER=wGroup, UNAME='gb_batch_Box' $
      , XOFFSET=fisv_top_geom.Xoffset+fisv_top_geom.Xsize/4 $
      , YOFFSET=fisv_top_geom.Yoffset+fisv_top_geom.Ysize/6 $
      , TITLE='GB CheckBox' , SPACE=3 , XPAD=3 , YPAD=3 $
      , COLUMN=1)

  ;
  GB_BATCH_Title = Widget_Label(gb_batch_Box,  $
      UNAME='gb_batch_Box_Base' ,/ALIGN_CENTER  $
      ,VALUE='Select GB modules to run')


  ; Block for Clear Flag command
  CF_BLK = Widget_Base(gb_batch_Box, UNAME='CF_BLK' ,FRAME=1  $
      ,XSIZE=212 ,/ALIGN_CENTER ,/BASE_ALIGN_CENTER  $
      ,SPACE=3 ,XPAD=3 ,YPAD=3 ,ROW=1)

  CFBASE = Widget_Base(CF_BLK, UNAME='CFBASE' $
      ,COLUMN=1 ,/NONEXCLUSIVE)

  CF = Widget_Button(CFBASE, UNAME='CF'  $
      ,/ALIGN_LEFT ,VALUE='Clear Flags')


  ; Block for GB1
  GB_BLK1 = Widget_Base(gb_batch_Box, UNAME='GB_BLK1' ,FRAME=1  $
      ,XSIZE=212 ,/ALIGN_CENTER ,/BASE_ALIGN_CENTER  $
      ,SPACE=3 ,XPAD=3 ,YPAD=3 ,ROW=1)

  GBBASE_1 = Widget_Base(GB_BLK1, UNAME='GBBASE_1' $
      ,COLUMN=1 ,/NONEXCLUSIVE)

  GB1 = Widget_Button(GBBASE_1, UNAME='GB1'  $
      ,/ALIGN_LEFT ,VALUE='GB_Flag_Bad_Data')

  GB2 = Widget_Button(GBBASE_1, UNAME='GB2'  $
      ,/ALIGN_LEFT ,VALUE='GB_Set_Flag_Rstanom')

  GB3 = Widget_Button(GBBASE_1, UNAME='GB3'  $
      ,/ALIGN_LEFT ,VALUE='GB_Conv_to_Volt (w/o Noise Est.)')

  GB4 = Widget_Button(GBBASE_1, UNAME='GB4'  $
      ,/ALIGN_LEFT ,VALUE='GB_Ramp_Curve_Corr')

  GB5 = Widget_Button(GBBASE_1, UNAME='GB5'  $
      ,/ALIGN_LEFT ,VALUE='GB_Differentiation')

  GB6 = Widget_Button(GBBASE_1, UNAME='GB6'  $
      ,/ALIGN_LEFT ,VALUE='GB_Periodic_Noise')


  ; Block for GB2
  GB_BLK2 = Widget_Base(gb_batch_Box, UNAME='GB_BLK2' ,FRAME=1  $
      ,XSIZE=212 ,/ALIGN_CENTER ,/BASE_ALIGN_CENTER  $
      ,SPACE=3 ,XPAD=3 ,YPAD=3 ,ROW=1)

  GBBASE_2 = Widget_Base(GB_BLK2, UNAME='GBBASE_2' $
      ,COLUMN=1 ,/NONEXCLUSIVE)

  GB7 = Widget_Button(GBBASE_2, UNAME='GB7'  $
      ,/ALIGN_LEFT ,VALUE='GB_Set_Glitch_Status_MMT')

  GB8 = Widget_Button(GBBASE_2, UNAME='GB8'  $
      ,/ALIGN_LEFT ,VALUE='GB_Set_Glitch_Status_GP')


  ; Block for GB3
  GB_BLK3 = Widget_Base(gb_batch_Box, UNAME='GB_BLK3' ,FRAME=1  $
      ,XSIZE=212 ,/ALIGN_CENTER ,/BASE_ALIGN_CENTER  $
      ,SPACE=3 ,XPAD=3 ,YPAD=3 ,ROW=1)

  GBBASE_3 = Widget_Base(GB_BLK3, UNAME='GBBASE_3' $
      ,COLUMN=1 ,/NONEXCLUSIVE)

  GB9 = Widget_Button(GBBASE_3, UNAME='GB9'  $
      ,/ALIGN_LEFT ,VALUE='GB_Make_DC_Cal_Lamp_Table')

  GB10 = Widget_Button(GBBASE_3, UNAME='GB10'  $
      ,/ALIGN_LEFT ,VALUE='GB_Make_Dark_Table')

  GB11 = Widget_Button(GBBASE_3, UNAME='GB11'  $
      ,/ALIGN_LEFT ,VALUE='GB_Dark_Subtraction')

  GB12 = Widget_Button(GBBASE_3, UNAME='GB12'  $
      ,/ALIGN_LEFT ,VALUE='GB_DC_Responsivity_Corr')

  GB13 = Widget_Button(GBBASE_3, UNAME='GB13'  $
      ,/ALIGN_LEFT ,VALUE='GB_Flux_Calib')


  ;
  ButtonBase = Widget_Base(gb_batch_Box, UNAME='ButtonBase'  $
      ,/ALIGN_CENTER ,ROW=1 ,/GRID_LAYOUT)

  RUN_BUTTON = Widget_Button(ButtonBase, UNAME='RUN_BUTTON' $
      , XSIZE=80, /ALIGN_CENTER, VALUE='RUN GB')

  Cancel_BUTTON = Widget_Button(ButtonBase, UNAME='Cancel_BUTTON' $
      , /ALIGN_CENTER, VALUE='Cancel')


  ;
  IF n_elements(gb_batch_info) THEN BEGIN
    IF gb_batch_info.flag_cf   THEN Widget_Control, CF,  /SET_BUTTON
    IF gb_batch_info.flag_gb1  THEN Widget_Control, GB1, /SET_BUTTON
    IF gb_batch_info.flag_gb2  THEN Widget_Control, GB2, /SET_BUTTON
    IF gb_batch_info.flag_gb3  THEN Widget_Control, GB3, /SET_BUTTON
    IF gb_batch_info.flag_gb4  THEN Widget_Control, GB4, /SET_BUTTON
    IF gb_batch_info.flag_gb5  THEN Widget_Control, GB5, /SET_BUTTON
    IF gb_batch_info.flag_gb6  THEN Widget_Control, GB6, /SET_BUTTON
    IF gb_batch_info.flag_gb7  THEN Widget_Control, GB7, /SET_BUTTON
    IF gb_batch_info.flag_gb8  THEN Widget_Control, GB8, /SET_BUTTON
    IF gb_batch_info.flag_gb9  THEN Widget_Control, GB9, /SET_BUTTON
    IF gb_batch_info.flag_gb10 THEN Widget_Control, GB10, /SET_BUTTON
    IF gb_batch_info.flag_gb11 THEN Widget_Control, GB11, /SET_BUTTON
    IF gb_batch_info.flag_gb12 THEN Widget_Control, GB12, /SET_BUTTON
    IF gb_batch_info.flag_gb13 THEN Widget_Control, GB13, /SET_BUTTON
  ENDIF


  Widget_Control, /REALIZE, gb_batch_Box

  XManager, 'gb_batch_Box', gb_batch_Box, /NO_BLOCK

end
;
;
pro gb_batch, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
COMMON GBB_Share, fisv_top_id

  IF n_elements(wGroup) EQ 0 THEN wGroup=0
  fisv_top_id = wGroup

  gb_batch_Box, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
