; $Id: make_x_flux_tree.pro,v 1.3 2007/07/05 10:40:04 makiuti Exp $
;+
; NAME:
;       MAKE_X_FLUX_TREE
;
; PURPOSE:
;       This procedure makes the FLUX branches
;       in the X data selector of the FISv.
;       This procedure is called by FISv.
;
; AUTHOR:
;       ASTRO-F Data Reduction team
;       Web Page: http://www.ir.isas.jaxa.jp/ASTRO-F/iris_data/
;
; CATEGORY:
;       FIS Data Visualizer
;
; CALLING SEQUENCE:
;       make_x_flux_tree, widgetID
;
; MODIFICATION HISTORY:
;        Written by: Makiuti,S.
;-
pro make_x_flux_tree, widgetID
COMMON ShareFISv

  parentID = widgetID
  WHILE Widget_Info(parentID, /Parent) NE 0 DO BEGIN
     parentID = Widget_Info(parentID, /Parent)
  ENDWHILE

  Widget_Control, parentID, UPDATE=0

  X_TREENODE_49 = widget_info(parentID, find_by_uname='X_TREENODE_49')

  ; Get detector type (SW or LW)
  pixmax = (STRMATCH(tsd->Get_Datatype(), '*SW*', /FOLD_CASE) EQ 1) ? 100:75

  FOR i = 1, pixmax DO BEGIN

    IF (i LE 9) THEN BEGIN
      pix_str = string(i, format='(I1)')
    ENDIF ELSE IF ((i GE 10) AND (i LE 99)) THEN BEGIN
      pix_str = string(i, format='(I2)')
    ENDIF ELSE IF (i EQ 100) THEN BEGIN
      pix_str = string(i, format='(I3)')
    ENDIF

    temp_str1 = 'X_TREE_FLUX'+pix_str
    temp_str1 = Widget_Tree(X_TREENODE_49, UNAME='X_TREE_FLUX'+pix_str $
      , VALUE=pix_str, UVALUE='FLUX'+pix_str)

  ENDFOR

  Widget_Control, parentID, /UPDATE

end
