; $Id: make_x_irc_hk_tree.pro,v 1.6 2006/12/11 06:33:25 makiuti Exp $
;+
; NAME:
;       MAKE_X_IRC_HK_TREE
;
; PURPOSE:
;       This procedure makes the IRC_HK extension branch
;       in the X data selector of the FISv.
;       This procedure is called by FISv.
;
; AUTHOR:
;       ASTRO-F Data Reduction team
;       Web Page: http://www.ir.isas.ac.jp/ASTRO-F/iris_data/
;
; CATEGORY:
;       FIS Data Visualizer
;
; CALLING SEQUENCE:
;       make_x_irc_hk_tree, widgetID
;
; MODIFICATION HISTORY:
;        Written by: Makiuti,S.
;        2006/12/11  Last modified
;-
pro make_x_irc_hk_tree, widgetID

  parentID = widgetID
  WHILE Widget_Info(parentID, /Parent) NE 0 DO BEGIN
     parentID = Widget_Info(parentID, /Parent)
  ENDWHILE

  Widget_Control, parentID, UPDATE=0

  ;  ## IRC_HK Extension Root
  X_TREENODE_IRC_HK = widget_info(parentID, find_by_uname='X_TREENODE_IRC_HK')

  ; (1) Time
  X_TREENODE_IRC_HK_1 = Widget_Tree(X_TREENODE_IRC_HK, UNAME='X_TREENODE_IRC_HK_1'  $
      ,/FOLDER ,VALUE='Time')
    X_TREE_AFTIME = Widget_Tree(X_TREENODE_IRC_HK_1, UNAME='X_TREE_IRC_HK_AFTIME'  $
      ,VALUE='AFTIME', UVALUE='IRC_HK_AFTIME')
    X_TREE_PIMTIORG = Widget_Tree(X_TREENODE_IRC_HK_1, UNAME='X_TREE_IRC_HK_PIMTIORG'  $
      ,VALUE='PIMTIORG', UVALUE='IRC_HK_PIM_TI_ORG')
  ; (2) IRC Status
  X_TREENODE_IRC_HK_2 = Widget_Tree(X_TREENODE_IRC_HK, UNAME='X_TREENODE_IRC_HK_2'  $
      ,/FOLDER ,VALUE='Status')
    X_TREE_IRC_HK_BLANK = Widget_Tree(X_TREENODE_IRC_HK_2, UNAME='X_TREE_IRC_HK_BLANK'  $
      ,VALUE='Blank', UVALUE='IRC_HK_BLANK')
  ; (3) Analog Data
  X_TREENODE_IRC_HK_3 = Widget_Tree(X_TREENODE_IRC_HK, UNAME='X_TREENODE_IRC_HK_3'  $
      ,/FOLDER ,VALUE='Analg Data')
;    X_TREE_IRC_HK_IRC_MAINREF_TMP1 = Widget_Tree(X_TREENODE_IRC_HK_3, UNAME='X_TREE_IRC_HK_IRC_MAINREF_TMP1'  $
;      ,VALUE='IRC_MAINREF_TMP1', UVALUE='IRC_HK_IRC_MAINREF_TMP1')
;    X_TREE_IRC_HK_IRC_SUBREF_TMP = Widget_Tree(X_TREENODE_IRC_HK_3, UNAME='X_TREE_IRC_HK_IRC_SUBREF_TMP'  $
;      ,VALUE='IRC_SUBREF_TMP', UVALUE='IRC_HK_IRC_SUBREF_TMP')
;    X_TREE_IRC_HK_IRC_FPIP_TMP1 = Widget_Tree(X_TREENODE_IRC_HK_3, UNAME='X_TREE_IRC_HK_IRC_FPIP_TMP1'  $
;      ,VALUE='IRC_FPIP_TMP1', UVALUE='IRC_HK_IRC_FPIP_TMP1')

  Widget_Control, parentID, /UPDATE

end