; $Id: make_y_anlgtele_tree.pro,v 1.4 2006/03/23 06:23:01 baba Exp $
;+
; NAME:
;       MAKE_Y_ANLGTELE_TREE
;
; PURPOSE:
;       This procedure makes the analog telemetry branches
;       in the Y data selector of the FISv.
;       This procedure is called by FISv.
;
; AUTHOR:
;       ASTRO-F Data Reduction team
;       Web Page: http://www.ir.isas.ac.jp/ASTRO-F/iris_data/
;
; CATEGORY:
;       FIS Data Visualizer
;
; CALLING SEQUENCE:
;       make_y_anlgtele_tree, widgetID
;
; MODIFICATION HISTORY:
;        Written by: Makiuti,S.
;        2006/01/24  Last modified
;-
pro make_y_anlgtele_tree, widgetID

  parentID = widgetID
  WHILE Widget_Info(parentID, /Parent) NE 0 DO BEGIN
     parentID = Widget_Info(parentID, /Parent)
  ENDWHILE

  Widget_Control, parentID, UPDATE=0

  Y_TREENODE_3 = widget_info(parentID, find_by_uname='Y_TREENODE_3')

  ; (3) Analog Telemetry
  Y_TREE_PktID = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREE_PktID'  $
      ,VALUE='PacketID', UVALUE='PacketID')
  Y_TREENODE_28 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_28'  $
      ,VALUE='RstCntWideL', UVALUE='RstCntWideL')
  Y_TREENODE_29 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_29'  $
      ,VALUE='RstCntWideS', UVALUE='RstCntWideS')
  Y_TREENODE_30 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_30'  $
      ,VALUE='RstCntN170', UVALUE='RstCntN170')
  Y_TREENODE_31 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_31'  $
      ,VALUE='RstCntN60', UVALUE='RstCntN60')
  Y_TREENODE_32 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_32'  $
      ,VALUE='CalPlsCntAL', UVALUE='CalPlsCntAL')
  Y_TREENODE_33 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_33'  $
      ,VALUE='CalPlsCntAS', UVALUE='CalPlsCntAS')
  Y_TREENODE_34 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_34'  $
      ,VALUE='CalPlsCntB', UVALUE='CalPlsCntB')
  Y_TREE_ADecSW = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREE_ADecSW'  $
      ,VALUE='ADErrCntSW', UVALUE='ADErrCntSW')
  Y_TREE_ADecLW = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREE_ADecLW'  $
      ,VALUE='ADErrCntLW', UVALUE='ADErrCntLW')

  Y_TREE_MPosCnt = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREE_MPosCnt'  $
      ,VALUE='MPosCnt', UVALUE='MPosCnt')

  Y_TREENODE_35 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_35'  $
      ,VALUE='DacBiasWideS', UVALUE='DacBiasWideS')
  Y_TREENODE_36 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_36'  $
      ,VALUE='DacBiasN60', UVALUE='DacBiasN60')
  Y_TREENODE_37 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_37'  $
      ,VALUE='DacBiasWideL', UVALUE='DacBiasWideL')
  Y_TREENODE_38 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_38'  $
      ,VALUE='DacBiasN170', UVALUE='DacBiasN170')
  Y_TREENODE_39 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_39'  $
      ,VALUE='DacCalAS', UVALUE='DacCalAS')
  Y_TREENODE_40 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_40'  $
      ,VALUE='DacCalAL', UVALUE='DacCalAL')
  Y_TREENODE_41 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_41'  $
      ,VALUE='DacCalB', UVALUE='DacCalB')
  Y_TREENODE_42 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_42'  $
      ,VALUE='DacSinAS', UVALUE='DacSinAS')
  Y_TREENODE_43 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_43'  $
      ,VALUE='DacSinAL', UVALUE='DacSinAL')
  Y_TREENODE_44 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_44'  $
      ,VALUE='TpBody', UVALUE='TpBody')
  Y_TREENODE_45 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_45'  $
      ,VALUE='TpSW', UVALUE='TpSW')
  Y_TREENODE_46 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_46'  $
      ,VALUE='TpLW', UVALUE='TpLW')
  Y_TREENODE_47 = Widget_Tree(Y_TREENODE_3, UNAME='Y_TREENODE_47'  $
      ,VALUE='TpCalFT', UVALUE='TpCalFT')

  Widget_Control, parentID, /UPDATE

end