;#> frin_title.dc3
; Identifier	frin_title
;
; Purpose	make title for fringes plots
;
; Synopsis	result = frin_title( frid )
;
; Arguments	Name	I/O    Type:	 Description
;		------------------------------------------------------------
;		frid	 I     struct	 fringes-id (see fringes.pro
;
; Returns	result	 O     string	 plot title
;
; Description
;
;
;
;
; Comment
;
;
; Example	--
;
; Category	UTIL ( module: fringes )
;
; Filename	frin_title.pro
;
; Author	Do Kester
;
; Version	1.2
;
; History	1.0  07-03-2001 DK, first implementation of frin_title.pro
;		1.1  05-04-2001 DK, remove compile_opt
;		1.2  16-05-2001 DK, accomodate changes in frid
;#<
;===========================================================================

function frin_title, frid

; compile_opt idl2, hidden

ndet = n_elements( frid.detlist )
if ( frid.band GT 0 AND ndet GT 1 ) then begin
  if ( ndet LT 12 ) then begin
    pltitle = string( "dets =", frid.detlist, format='(a,12i3)' )
  endif else pltitle = string( "all dets of band", frid.band, format='(a,i2)' )
endif else pltitle = string( "detector =", frid.det, format="(a,i3)" )

pltitle = frid.sband + '  ' + pltitle + string( "  reset =", frid.reset, $
			    format="(a,i6)" )

return, pltitle
end

