;#> winset.dc1
; Identifier	winset
;
; Purpose	combines WSET and WINDOW (same interfaces)
;
; Synopsis	winset, windex, _extra=_e
;
; Arguments	Name	I/O    Type:	 Description
;		-------------------------------------------------------------
;		windex	 I     int	 index of the window to be selected
;		_extra	 I     struct	 extra info
;
; Returns
;
; Description	All the routines work as their equivalents (resp. wset, wshow
;		and wdelete) except that the don't crash when the device is
;		not a windowing system, like 'PS'.
;		Also when trying with WINSET, to open a window that is not yet
;		opened, it will just do so.
;
; Comment	I hate stupid IDL for this
;
;		Note that the routine WINDOW has become superfluous
;
;
; Example	--
;
; Category	UTIL ( module: winset )
;
; Filename	winset.pro
;
; Author	Do Kester
;
; Version	1.2
;
; History	1.0  07-03-2001 DK, first implementation as winset.pro
;		1.1  03-04-2001 DK, remove compile_opt
;               1.2  27-09-2001 FL, index for new window ge 0 and le 31
;#<
;===========================================================================

pro winset, windex, _extra=_e

; compile_opt idl2

if ( !d.name EQ 'X' OR !d.name EQ 'WIN' ) then begin
  if ( n_elements( windex ) EQ 0 ) then windex = 0
  device, window_state=window_state
  windex = ( windex > 0 ) < ( n_elements(window_state) - 1 )
  if ( window_state[windex] ) then wset, windex $
  else begin
    window, windex < 31, _extra=_e
    windex = !d.window
  endelse
endif

end

;===========================================================================


