;
;  supplies function for cal_fit1
;

Function cal1_respons, t, a
  bt = exp(-t/a[1])
  f  = a[0]*(1.D -bt)+a[2]

  Return, [f, 1.D -bt, -a[0]*bt*t/a[1]^2, 1.D]
End

;
; performs curve fitting with the following function and returns y(t1)
; where t1 may be an array
;
;  ref. S.H.Oh et al. 2004
;
Function gb_cal_fit1, y, t

;  initial guess for the coefficients
;
  a = findgen(3)
  a[1] = 0.1
  a[2] = min(y)
  a[0] = max(y)-a[2]

  fita = [1,1,1]

  t_0 = t - t[0]

  c = lmfit(t_0, y, a, FITA=fita, FUNCTION_NAME='cal1_respons', CHISQ=chisq, $
                          /double, CONVERGENCE=convergence, ITMAX=300)

IF (convergence EQ -1) THEN print, '  Converge failed in a module, gb_cal_fit1.pro.'

Return, a[0]+a[2]

End

