;
; Copyright (c) 2002, ASTRO-F Data Reduction Team.  All rights reserved.
;
;+
; NAME:
;	mmt_get_peak.pro
; PURPOSE:
;       Return the location of peak in the data array
; CATEGORY:
;	Green Box procedure in library in ASTRO-F pipeline.
; CALLING SEQUENCE:
;
; INPUTS:
;	data         input data
;
; OUTPUTS:
;       peak         data point at peak
;
; RESTRICTIONS:
;	
; PROCEDURE:
;
; EXAMPLE:
;
; REFERENCE:
;
; MODIFICATION HISTORY:
; 	Aug. 2004		Written by T.Takagi
;    
;-

FUNCTION mmt_get_peak, data

sig_peak = where(data eq max(data),cnt)

peak = sig_peak[n_elements(sig_peak)-1]
;peak = sig_peak[0]

RETURN, peak
END
