; returns the offset in arcminutes

FUNCTION im_get_offset, det, band

alpha = 26.5 * !PI / 180

sa = sin( alpha )
ca = cos( alpha )

arcpmm = 7.5 / 9.0

longwidth = 15 * arcpmm

longpix = longwidth / 15

shortpix = 12 * longpix / 20

if ( det LE 0 ) then return, [0.0,0.0]

if ( band EQ "SW" OR band EQ "SN" ) THEN BEGIN
  if ( det LE 60 ) then begin				  ; SW
    kd = det - 1
    y = 20 + ( ( kd / 20 ) - 1 ) * shortpix
    x = ( ( kd MOD 20 ) - 10 ) * shortpix - 1.5 * longpix
  endif else if ( det LE 100 ) then begin		  ; SN
    kd = det - 61
    y = 12.5 + ( ( kd / 20 ) - 0.5 ) * shortpix
    x = ( ( kd MOD 20 ) - 10 ) * shortpix + 1.5 * longpix
  endif else begin
    x = 0
    y = 0
  endelse
ENDIF ELSE BEGIN
  if ( det LE 45 ) then begin		      ; LW
    kd = det - 1
    y = 20 + ( ( kd / 15 ) - 1 ) * longpix
    x = ( ( kd MOD 15 ) - 7.5 ) * longpix
  endif else if ( det LE 75 ) then begin		 ; LN
    kd = det - 46
    y = 12.5 + ( ( kd / 15 ) - 0.5 ) * longpix
    x = ( ( kd MOD 15 ) - 7.5 ) * longpix
  endif else begin
    x = 0
    y = 0
  endelse
ENDELSE

return, [ x * ca + y * sa, -x * sa + y + ca ]

end
