pro make_detcorner_ccf, filename, band=band

hdr = ccf_create_new_header()
hdr.name='CRNR' + band
hdr.set_no=001
hdr.rev_no=001
hdr.status='TEST'
hdr.range = [0.0,0.0]
hdr.creator = 'DK'
hdr.comment ='detector corners for the ' + band + 'W band, wide resp narrow '

nd = ( band EQ 'S' ) ? 100 : 75

ccf = { x_ul_nominal	 : fltarr( nd ), $	    ; upper left
	x_ur_nominal	 : fltarr( nd ), $	    ; upper right
	x_lr_nominal	 : fltarr( nd ), $	    ; lower right
	x_ll_nominal	 : fltarr( nd ), $	    ; lower left
	y_ul_nominal	 : fltarr( nd ), $
	y_ur_nominal	 : fltarr( nd ), $
	y_lr_nominal	 : fltarr( nd ), $
	y_ll_nominal	 : fltarr( nd ), $
	x_ul_distorted	 : fltarr( nd ), $
	x_ur_distorted	 : fltarr( nd ), $
	x_lr_distorted	 : fltarr( nd ), $
	x_ll_distorted	 : fltarr( nd ), $
	y_ul_distorted	 : fltarr( nd ), $
	y_ur_distorted	 : fltarr( nd ), $
	y_lr_distorted	 : fltarr( nd ), $
	y_ll_distorted	 : fltarr( nd ), $
	ndet		 : nd }

openr, unit, filename, /get_lun

line = ' '
for k = 1, 3 do readf, unit, line, format='(a)'     ; skip headerlines

kk = ( nd * 3 ) / 5
for k = 0, nd-1 do begin
  readf, unit, row, det, xnom, ynom, xdis, ydis, xuln, yuln, xuld, yuld, $
    xurn, yurn, xurd, yurd, xlrn, ylrn, xlrd, ylrd, xlln, ylln, xlld, ylld, $
    format='(2i8,20f8.3)'

print, row, det, xuln, yuln, xuld, yuld, $
    xurn, yurn, xurd, yurd, xlrn, ylrn, xlrd, ylrd, xlln, ylln, xlld, ylld

    ccf.x_ul_nominal[kk]   = xuln
    ccf.x_ur_nominal[kk]   = xurn
    ccf.x_lr_nominal[kk]   = xlrn
    ccf.x_ll_nominal[kk]   = xlln
    ccf.y_ul_nominal[kk]   = yuln
    ccf.y_ur_nominal[kk]   = yurn
    ccf.y_lr_nominal[kk]   = ylrn
    ccf.y_ll_nominal[kk]   = ylln
    ccf.x_ul_distorted[kk] = xuld
    ccf.x_ur_distorted[kk] = xurd
    ccf.x_lr_distorted[kk] = xlrd
    ccf.x_ll_distorted[kk] = xlld
    ccf.y_ul_distorted[kk] = yuld
    ccf.y_ur_distorted[kk] = yurd
    ccf.y_lr_distorted[kk] = ylrd
    ccf.y_ll_distorted[kk] = ylld
    kk = ( kk EQ nd - 1 ) ? 0 : kk + 1


endfor

free_lun, unit

r = ccf_write_ccf_file( 'CRNR' + band + '_001_001.ccf', ccf, hdr, /overwrite )

end
