; $Id: sample.pro,v 1.6 2003/04/23 11:22:07 baba Exp $
;
; Copyright(C) 2002, ASTRO-F Data Reduction Team.  All rights reserved.
;
; Sample script in order to access TSD
; See 'ASTRO-F FIS/Survey Data Structure' in detail.
;

PROFILER, /SYSTEM
HELP, /MEMORY

infile = '/home/baba/ASTRO-F/fits/01_lw.fits'

PRINT, '-- Object initializer -----------------------------------------------'
; Get an object reference.  The first argument is fixed to 'tsd'.
tsd = OBJ_NEW('tsd')
IF NOT OBJ_VALID(tsd) THEN MESSAGE, 'TSD object is not initialized.'


PRINT, '-- Read TSD using object method tsd->Read_TSD() ---------------------'
; Read the TSD file and extract data to the main memory.
; The argument is the filename of TSD.
IF NOT tsd->Read_TSD(infile) THEN MESSAGE, 'Reading error occurred.'
HELP, /MEMORY


PRINT, '-- Test for debug and verbose printing ------------------------------'
EVAL, "PRINT, '(1)!Debug = ', !Debug"
DPRINT, 'debug message1'
EVAL, "setDebug"
EVAL, "PRINT, '(2)!Debug = ', !Debug"
DPRINT, 'debug message2'

EVAL, "PRINT, '(1)!QUIET = ', !QUIET"
VPRINT, 'verbose message1'
EVAL, "BeVerbose"
EVAL, "PRINT, '(2)!QUIET = ', !QUIET"
VPRINT, 'verbose message2'

EVAL, "unsetDebug"


PRINT, '-- Test for access to header components -----------------------------'
PRINT, 'DataType: ', tsd->getProperty('DataType')

dummy = tsd->setProperty('Version', '1.0')
PRINT, 'Version: ', tsd->getProperty('Version')

dummy = tsd->setProperty('History', 'sample data')
h = tsd->header::Read_TSD_Header('infile')
h = tsd->Read_TSD_Header('infile')
HELP, h, {header}

dummy = tsd->setProperty('History', 'New test histroy is included into the header.')
PRINT, "History:  ", tsd->getProperty('History')
PRINT, "History:  ", h->getProperty('History')
PRINT, "DataType: ", h->getProperty('DataType')


PRINT, '-- Test for access to data components -------------------------------'

; Get the values of the member of TSD.
cti = tsd->Get_Value_TSD('CTI')
vdet = tsd->Get_Value_TSD('FIS_VDET')
vdet10 = tsd->Get_Value_TSD('FIS_VDET[9]')
HELP, cti, vdet, vdet10
; Set the values of the member of TSD
test = Indgen(1000)
dummy = tsd->Set_Value_TSD('FIS_RSTCNTWIDEL', test)

; Get the status of FIS
rstwidelon = tsd->Get_Status_TSD('RSTWIDELON')
HELP, rstwidelon
; Set the status of FIS
;dummy = tsd->Set_Status_TSD('RSTWIDELON', rstwidelon)

; Get the flag of FIS
in_saa = tsd->Get_Flag_TSD('IN_SAA')
HELP, in_saa
; Set the status of FIS
;dummy = tsd->Set_Flag_TSD('IN_SAA', in_saa)


PRINT, '-- HELP -------------------------------------------------------------'
HELP
HELP, /HEAP_VARIABLES
;HELP, /SOURCE_FILES
HELP, /MEMORY

;PROFILER, /report


PRINT, '-- Write TSD using object method tsd->Write_TSD() -------------------'
dummy = tsd->Write_TSD('output.fits')


; EOF
